//Patch dla obiektu Date

if(!Date.prototype.toDateString )
	Date.prototype.toDateString = function (){
		var DOW = ["Ndz", "Pn", "Wt", "Sr", "Czw", "Pt", "So"];
		var Month = ["sty.", "lut.", "mar.", "kwie.", "maj", "cze.", "lip.", "sie.", "wrz.", "pazdz.", "list.", "gru."];
		return ( DOW[this.getDay()] + " " + Month[this.getMonth()] + " " +
				this.getDate() + " " + this.getFullYear() );
	};

if (!Date.prototype.toTimeString )
	Date.prototype.toTimeString = function (){
		var hours = parseInt(this.getTimezoneOffset()/60);
		var mins = Math.abs(this.getTimezoneOffset()) - Math.abs(hours * 60);
		var s = (hours < 0)? "-" : "+";
		hours = Math.abs(hours);
		
		var offset = s + twoDigit(hours) + twoDigit(mins);
		
		return (twoDigit(this.getHours()) + ":" + twoDigit(this.getMinutes()) + ":" +
				twoDigit(this.getSeconds()) + " " + offset );
		
		function twoDigit( num ){
			if( num < 10 ) return "0" + num;
			return "" + num;
		}
	}
if(!Date.prototype.toLocaleDateString )
	Date.prototype.toLocaleDateString = Date.prototype.toDateString;

if(!Date.prototype.toLocaleTimeString )
	Date.prototype.toLocaleTimeString = Date.prototype.toTimeString;

//  Date_toTimeDate()

//	Jest to metoda udogodnienia wzgldem tekstu, aby zaoszczdzi nieco wpisywania;
//	w wersji ostatecznej moe zdecydujemy si pomin j i po prostu przekierowa
//	uytkownika, aby include'owa zamiast tego plik String_utils.js

String.prototype.contains=String_contains;

function String_contains(character)
{
	var value=false;

	value=this.indexOf(character)!=-1;

	return value;
}

//	To jest wanie funkcja formatujca dat, jest oparta z grubsza na funkcji PHP date()
//	-zob http://www.php.net/manual/en/function.date.php odnonie oryginau; zauwa
//	e nie mamy tu potrzeby opcjonalnego argumentu znacznika czasu-timestamp zawartego w wersji PHP,
//	poniewa obiekt Date sam podaje t informacj. Naley take zauway, e 
//	usunlimy cz argumentw tam, gdzie zduplikowane byyby metody Date, ktre istniej ju
//	lub gdy wedle naszego wyczucia nie byoby na nie wikszego zapotrzebowania, np. "Swatch
//	Internet Time." Dokonalimy take pewnych innych zmian, aby argumenty tej metody stay si 
//	nieco bardziej spjne. 
// Uwaga tumacza - niektre formaty daty s oczywicie niepoprawne dla jzyka polskiego,
// sugerowane wykorzystanie funkcji z argumentami "h:i W,dNY"

/*
		ARGUMENTY:

    a - "am" or "pm"
    A - "AM" or "PM"
    a/A pominite: czas 24-godzinny
    
    d - dzie miesica, bez zer (1-31)
    D - dzie miesica, poprzedzony zerami (01-31)
    
    h - godziny, bez zer
    H - godziny poprzedzone zerami
    
    I - minuty (zawsze poprzedzone zerami)
    
    m - miesic, numeryczny, bez zera ("8")
    M - miesic, numeryczny, poprzedzony zerem ("08")
    n - miesic, tekst, krtki ("Sie.")
    N - miesic, tekst, dugi ("Sierpie")
    
    o - Przyrostek liczebnika porzdkowego, tekstowy, 2 znaki; tj. "-y", "nd" [maa litera "O"]
    
    S - sekundy (zawsze pokazane poprzedzajce zera)
    
    w - dzie tygodnia, krtki ("Pt")
    W - dzie tygodnia, dugi ("Pitek")
    w/W pominite: dzie tygodnia niewywietlany
    
    y - rok 2-cyfrowy ("01") [po prostu obcina rok 4-cyfrowy]
    Y - rok 4-cyfrowy ("2001")    
*/

/*

		Wykorzystanie:
		
		Argumenty tej funkcji wprowadzane s jako cig tekstowy, spacja oddziela czas i dat.
		Separator wykorzystany w tych grupach pojawia si take na wyjciu.
		Spacja wstawiana jest po kadym elemencie grupy, z wyjtkami podanymi poniej.
		Po przecinkach wykorzystanych wewntrz grupy daty bdzie wstawiona dodatkowa spacja.
		Wewntrz daty zduplikowany jest porzdek argumentw.
		Argumenty pominite s ignorowane z wyjtkami podanymi powyej.
		
		Typowy przykad:
		myDate=new Date(); //	jest 9:20:30PM Pt 03 Sierpnia 2001 (na przykad)
		myDate.toTimeDate("h:I:Sa W,Ndo,Y");
		//	wynik jest: "9:20:30pm Pitek, 3-ci Sierpnia, 2001"
		myDate.toTimeDate("H.I D-m-y");
		//	wynik jest: "21.20 03-Sie.-01"
		myDate.toTimeDate("Y-M-D");
		//	wynik jest: "2001-08-03"
*/

String.prototype.contains=String_contains;

function String_contains(aChar)
{
	return this.indexOf(aChar)!=-1;
}

String.prototype.isAlphaNumeric=String_isAlphaNumeric;

function String_isAlphaNumeric()
{
  return this.match(/[0-9a-zA-Z]/)!=null;
}


Date.prototype.toTimeDate=Date_toTimeDate;

function Date_toTimeDate(format)
{
	var output="";
	var uFormat=format.toUpperCase();
	var fORMAT=format.toLowerCase();
	
	var myTime="";
	var myDate="";
	
	var myHours,myMinutes,myAmPm;
	var mySeconds="";
	var myWeekDay,myDate,myMonth,myYear;
	
	var separator="";

	var myTimeFormat="";
	var myDateFormat="";
	
	var tIMEfORMAT="";
	var dATEfORMAT="";
	
	var shortDays=["Ndz","Pn","Wt","r","Czw","Pt","So"];
	var longDays=["niedziela","poniedziaek","wtorek","roda","czwartek","pitek","sobota"];
	
	var shortMonths=["sty.","lut.","mar.","kwie.","maja","czer.","lip.","sie.","wrz.","pad.","list.","gru."];
	var longMonths=["stycznia","lutego","marca","kwietnia","maja","czerwca","lipca","sierpnia","wrzenia","padziernika","listopada","grudnia"];
	
	if(format.contains(" "))
	{
		myTimeFormat=format.split(" ")[0];
		myDateFormat=format.split(" ")[1];
	}
	else
	{
		if(uFormat.contains("H")||uFormat.contains("I")||uFormat.contains("S"))
			myTimeFormat=format;
		else
			myDateFormat=format;
	}
	
	if(myTimeFormat!="")
	{
		tIMEfORMAT=myTimeFormat.toUpperCase();
		if(tIMEfORMAT.contains("H"))
		{
			myHours=this.getHours();
			if(tIMEfORMAT.contains("A"))
			{
				if(myHours>12)
				{
					myHours-=12;
					myTime+=myTimeFormat.contains("a")?"pm":" po po.";
				}
				else
					myTime+=myTimeFormat.contains("a")?"am":" rano";
			}
			if(myTimeFormat.contains("H")&&myHours<10)
					myHours="0"+myHours;
			separator=tIMEfORMAT.charAt(tIMEfORMAT.indexOf("H")+1);
			if(separator!=" "&&separator!="A")myHours+=separator;
		}
		if(tIMEfORMAT.contains("I"))
		{
			myMinutes=this.getMinutes();
			if(myMinutes<10)myMinutes="0"+myMinutes;
			separator=tIMEfORMAT.charAt(tIMEfORMAT.indexOf("I")+1);
			if(separator!=" "&&separator!="A")myMinutes+=separator;
		}
		if(tIMEfORMAT.contains("S"))
		{
			mySeconds=this.getSeconds();
			if(mySeconds<10)mySeconds="0"+mySeconds;
		}
		myTime=myHours+myMinutes+mySeconds+myTime+" ";
	}
	
	if(myDateFormat!="")
	{
    myDate="";
    var temp="";
    var myChar="";
    for(var i=0;i<myDateFormat.length;i++)
	  {
	    var prevChar=myChar;
	    myChar=myDateFormat.charAt(i);
	    var nextChar=i<format.length?myDateFormat.charAt(i+1):null;
			
			if(myChar.isAlphaNumeric())
			{
    		if(myChar=="d"||myChar=="D")
        	temp=this.getDate();
    		if(myChar=="d")
    			if(temp<10)
      			temp="0"+temp;

    		if(myChar=="m"||myChar=="M"||myChar=="n"||myChar=="N")
      		temp=this.getMonth();
    		if(myChar=="m"||myChar=="M")
      		temp++;
    		if(myChar=="M"&&temp<10)
      		temp="0"+temp;

    		if(myChar=="n")
      		temp=shortMonths[temp-0];
    		if(myChar=="N")
      		temp=longMonths[temp-0];

    		if(myChar=="o")
    		{
    			var d=this.getDate()+"";
      		switch( d.charAt( d.length-1) )
      		{
        		case "1":
          		temp+="-szy";
        		break;

        		case "2":
          		temp+="-gi";
        		break;

        		case "3":
          		temp+="-ci";
        		break;

        		default:
          		temp+="-ty";
        		break;
        	}
      	}

      if(myChar=="w"||myChar=="W")
        temp=this.getDay();
      if(myChar=="w")
        temp=shortDays[temp];
      if(myChar=="W")
        temp=longDays[temp];

      if(myChar=="y"||myChar=="Y")
        temp=this.getFullYear()+"";
      if(myChar=="y")
        temp=temp.substr(temp.length-2,temp.length-1);

			if(nextChar.isAlphaNumeric()&&nextChar!="o")
				temp+=" ";
    }
    else
     	temp=myChar;

    if(myChar==",")
    	temp+=" ";

	  myDate+=temp;
  	temp="";
    }
  }
  output=myTime+" "+myDate;
  return output;
}

//  Date_isLeapYear()

function Date_isLeapYear( intYear )
{ 
  return (intYear%400==0 ? true:
          (intYear%100==0 ? false:
	       (intYear%4==0 ? true:false )
          )
         );
}

//  Date_daysInMonth()

function Date_daysInMonth()
{
  switch( this.getMonth()+1 )
  {
    case 9:
    case 4:
    case 6:
    case 11:
      return 30;
      break;
    
    case 2:
      return (  ( this.getFullYear() ).isLeapYear() ? 29 : 28  );
      break;

    default:
      return 31;
      break;
  }
}

